; Business-Class/theme.jl

;; Copyright (C) 1999 Dennis Cranston, <dcransto@slip.net>

;; This file is a sawmill theme based on CDE & Windows.  It is designed to be 
;; clean and to increase productivity.  

;; Business-Class is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; Business-Class is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


;; ___Font Definition___
(defvar Business-Class:font 
  (get-font "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1"))


;; ___Default Window Image Definitions___

;; 2x4
(defvar Business-Class:bottom-images (list 
  (make-image "bottom_inactive.png")
  (make-image "bottom_active.png")))

;; 2x4
(defvar Business-Class:top-images (list 
  (make-image "top_inactive.png")
  (make-image "top_active.png")))

;; 25x16
(defvar Business-Class:title-bar-images (list 
  (make-image "title_bar_inactive.png")
  (make-image "title_bar_active.png")))

;; 19x20
(defvar Business-Class:top-right-images (list 
  (make-image "top_right_inactive.png")
  (make-image "top_right_active.png")))

;; 20x20
(defvar Business-Class:top-left-images (list 
   (make-image "top_left_inactive.png")
   (make-image "top_left_active.png")))

;; 20x20
(defvar Business-Class:bottom-left-images (list 
  (make-image "bottom_left_inactive.png")
  (make-image "bottom_left_active.png")))

;; 20x20
(defvar Business-Class:bottom-right-images (list 
  (make-image "bottom_right_inactive.png")
  (make-image "bottom_right_active.png")))

;; 16x16
(defvar Business-Class:close-images (list 
  (make-image "close_normal_inactive.png")
  (make-image "close_normal_active.png")
   nil
  (make-image "close_clicked.png")))

;; 15x16
(defvar Business-Class:maximize-images (list 
  (make-image "maximize_inactive.png")
  (make-image "maximize_active.png")
   nil
  (make-image "maximize_clicked.png")))

;; 17x16
(defvar Business-Class:iconify-images (list 
  (make-image "minimize_inactive.png")
  (make-image "minimize_active.png")
   nil
  (make-image "minimize_clicked.png")))
					   
;; 16x16
(defvar Business-Class:menu-images (list 
  (make-image "menu_inactive.png")
  (make-image "menu_active.png")
   nil
  (make-image "menu_clicked.png")))

;; 4x2
(defvar Business-Class:left-images (list 
  (make-image "left_inactive.png")
  (make-image "left_active.png")))

;; 4x2
(defvar Business-Class:right-images (list 
  (make-image "right_inactive.png")
  (make-image "right_active.png")))


;; __Shaded Window Image Definitions__

;; 19x19
(defvar Business-Class:s-top-right-images (list 
  (make-image "s_top_right_inactive.png")
  (make-image "s_top_right_active.png")))

;; 20x19
(defvar Business-Class:s-top-left-images (list 
  (make-image "s_top_left_inactive.png")
  (make-image "s_top_left_active.png")))


;; __Default Window Frame Definition__
(defvar Business-Class:frame
  `(
    ;; title bar
    ((background . ,Business-Class:title-bar-images)
     (foreground . ("black" "white"))
     (font . ,Business-Class:font)
     (text . window-name)
     (x-justify . 18)
     (y-justify . -2)
     (top-edge . -16)
     (left-edge .  0)
     (right-edge . 0)
     (class . title))

    ;; top image
    ((background . ,Business-Class:top-images)
     (top-edge . -19)
     (left-edge .  0)
     (right-edge . 0)
     (class . top-border))
     
    ;; menu button
    ((background . ,Business-Class:menu-images)
     (top-edge . -16)
     (left-edge .  0)
     (class . menu-button))

    ;; left border
    ((background . ,Business-Class:left-images)
     (left-edge .  -4)
     (top-edge   .  0)
     (bottom-edge . 0)
     (class . left-border))

    ;; top-right corner
    ((background . ,Business-Class:top-right-images)
     (right-edge . -4)
     (top-edge  . -19)
     (class . top-right-corner))

    ;; top-left corner
    ((background . ,Business-Class:top-left-images)
     (left-edge . -4)
     (top-edge . -19)
     (class . top-left-corner))
     
    ;; right border
    ((background . ,Business-Class:right-images)
     (right-edge . -4)
     (top-edge   .  1)
     (bottom-edge . 0)
     (class . right-border))

    ;; bottom border
    ((background . ,Business-Class:bottom-images)
     (left-edge   .  0)
     (right-edge  .  0)
     (bottom-edge . -4)
     (class . bottom-border))

    ;; bottom-left corner
    ((background . ,Business-Class:bottom-left-images)
     (left-edge   . -4)
     (bottom-edge . -4)
     (class . bottom-left-corner))

    ;; bottom-right corner
    ((background . ,Business-Class:bottom-right-images)
     (right-edge  . -4)
     (bottom-edge . -4)
     (class . bottom-right-corner))

    ;; iconify button
    ((background . ,Business-Class:iconify-images)
     (right-edge . 29)
     (top-edge  . -16)
     (class . iconify-button))

    ;; maximize button
    ((background . ,Business-Class:maximize-images)
     (right-edge . 14)
     (top-edge  . -16)
     (class . maximize-button))

    ;; delete button
    ((background . ,Business-Class:close-images)
     (right-edge . -1)
     (top-edge  . -16)
     (class . close-button))
    ))


; __Shaped Window Frame Definition__
(defvar Business-Class:shaped-frame
  `(
    ;; title bar
    ((background . ,Business-Class:title-bar-images)
     (foreground . ("black" "white"))
     (font . ,Business-Class:font)
     (text . window-name)
     (x-justify . 18)
     (y-justify . -2)
     (top-edge . -16)
     (left-edge .  0)
     (right-edge . 0)
     (class . title))

    ;; menu button
    ((background . ,Business-Class:menu-images)
     (top-edge . -16)
     (left-edge .  0)
     (class . menu-button))

    ;; top image
    ((background . ,Business-Class:top-images)
     (top-edge . -19)
     (left-edge  . 0)
     (right-edge . 0)
     (class . title))

    ;; top-right corner
    ((background . ,Business-Class:s-top-right-images)
     (right-edge . -4)
     (top-edge  . -19)
     (class . title))

    ;; top-left corner
    ((background . ,Business-Class:s-top-left-images)
     (left-edge . -4)
     (top-edge . -19)
     (class . title))

    ;; iconify button
    ((background . ,Business-Class:iconify-images)
     (right-edge . 29)
     (top-edge  . -16)
     (class . iconify-button))

    ;; maximize button
    ((background . ,Business-Class:maximize-images)
     (right-edge . 14)
     (top-edge  . -16)
     (class . maximize-button))

    ;; delete button
    ((background . ,Business-Class:close-images)
     (right-edge . -1)
     (top-edge  . -16)
     (class . close-button))
    ))


; __Transient Window Frame Definition__
(defvar Business-Class:transient-frame
  `(
    ;; title bar
    ((background . ,Business-Class:title-bar-images)
     (foreground . ("black" "white"))
     (font . ,Business-Class:font)
     (text . window-name)
     (x-justify . 18)
     (y-justify . -2)
     (top-edge . -16)
     (left-edge  . 0)
     (right-edge . 0)
     (class . title))
 
    ;; top image
    ((background . ,Business-Class:top-images)
     (top-edge . -19)
     (left-edge  . 0)
     (right-edge . 0)
     (class . top-border))
     
    ;; menu button
    ((background . ,Business-Class:menu-images)
     (top-edge . -16)
     (left-edge  . 0)
     (class . menu-button))

    ;; left border
    ((background . ,Business-Class:left-images)
     (left-edge  . -4)
     (top-edge    . 0)
     (bottom-edge . 0)
     (class . left-border))

    ;; top-right corner
    ((background . ,Business-Class:top-right-images)
     (right-edge . -4)
     (top-edge  . -19)
     (class . top-right-corner))

    ;; top-left corner
    ((background . ,Business-Class:top-left-images)
     (left-edge . -4)
     (top-edge . -19)
     (class . top-left-corner))
     
    ;; right border
    ((background . ,Business-Class:right-images)
     (right-edge . -4)
     (top-edge    . 1)
     (bottom-edge . 0)
     (class . right-border))

    ;; bottom border
    ((background . ,Business-Class:bottom-images)
     (left-edge    . 0)
     (right-edge   . 0)
     (bottom-edge . -4)
     (class . bottom-border))

    ;; bottom-left corner
    ((background . ,Business-Class:bottom-left-images)
     (left-edge   . -4)
     (bottom-edge . -4)
     (class . bottom-left-corner))

    ;; bottom-right corner
    ((background . ,Business-Class:bottom-right-images)
     (right-edge  . -4)
     (bottom-edge . -4)
     (class . bottom-right-corner))

    ;; delete button
    ((background . ,Business-Class:close-images)
     (right-edge . -1)
     (top-edge  . -16)
     (class . close-button))
    ))


; __Shaped-Transient Window Frame Definition__
(defvar Business-Class:shaped-transient-frame
  `(
    ;; title bar
    ((background . ,Business-Class:title-bar-images)
     (foreground . "white")
     (font . ,Business-Class:font)
     (text . window-name)
     (x-justify . 18)
     (y-justify . -2)
     (top-edge . -16)
     (left-edge  . 0)
     (right-edge . 0)
     (class . title))

    ;; menu button
    ((background . ,Business-Class:menu-images)
     (top-edge . -16)
     (left-edge  . 0)
     (class . menu-button))

    ;; top image
    ((background . ,Business-Class:top-images)
     (top-edge . -19)
     (left-edge  . 0)
     (right-edge . 0)
     (class . title))

    ;; top-right corner
    ((background . ,Business-Class:s-top-right-images)
     (right-edge . -4)
     (top-edge  . -19)
     (class . title))

    ;; top-left corner
    ((background . ,Business-Class:s-top-left-images)
     (left-edge . -4)
     (top-edge . -19)
     (class . title))
     
    ;; delete button
    ((background . ,Business-Class:close-images)
     (right-edge . -1)
     (top-edge  . -16)
     (class . close-button))
    ))


;; __Frame Style__
(defun Business-Class:frame-style (w type)
  (cond ((eq type 'shaped)
	 'Business-Class:shaped-frame)
	((eq type 'transient)
	 'Business-Class:transient-frame)
	((eq type 'shaped-transient)
	 'Business-Class:shaped-transient-frame)
	((eq type 'unframed)
	 'nil-frame)
	(t
	 'Business-Class:frame)))

(add-frame-style 'Business-Class 'Business-Class:frame-style)
